import * as fs from 'fs';
import * as path from 'path';
import Spin from './Spin';

export default class ConfigReader {
  private filePath: string;
  private spin: Spin;

  constructor(filePath: string, spin: Spin) {
    this.filePath = filePath;
    this.spin = spin;
    this._readConfig();
  }

  private _readConfig() {
    let configObject: any;
    if (path.extname(this.filePath) === '.json') {
      const json = JSON.parse(this.filePath);
      configObject = json.spin ? json.spin : json;
    } else {
      const exports = this.spin.require(this.filePath);
      configObject = exports instanceof Function ? exports(this.spin) : exports;
    }
    this._normalizeConfig(configObject);
  }

  private _normalizeConfig(configObject: any) {}
}
